#include "Sprite.h"
#include "Vram.h"
#include "VVram.h"
#include "Chars.h"

constexpr byte InvalidPattern = 0xff;

Sprite[SpriteCount] Sprites;

void InitSprites()
{
    HideAllSprites();
}

void HideAllSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        p->pattern = InvalidPattern;
        p->oldPattern = InvalidPattern;
    }
}


void ShowSprite(byte index, byte x, byte y, byte pattern)
{
    ptr<Sprite> p;
    p = Sprites + index;
    p->x = x;
    p->y = y;
    p->pattern = pattern;
}


void HideSprite(byte index) 
{
    ptr<Sprite> p;
    p = Sprites + index;
    p->pattern = InvalidPattern;
}


void EraseSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        if (p->oldPattern != InvalidPattern) {
            byte x, y, size;
            x = p->oldX;
            y = p->oldY;
            if (p->oldPattern >= Pattern_FighterBullet) {
                size = 1;
            }
            else {
                size = 2;
            }
            if (y + size <= VVramHeight && x + size <= VVramWidth) {
                EraseBackup(x, y, size);
            }
        }
    }
}


void DrawSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        if (p->pattern != InvalidPattern) {
            byte x, y, size;
            x = p->x;
            y = p->y;
            if (p->pattern >= Pattern_FighterBullet) {
                size = 1;
            }
            else {
                size = 2;
            }
            if (y + size <= VVramHeight && x + size <= VVramWidth) {
                DrawSprite(x, y, p->pattern, size);
            }
        }
        p->oldX = p->x;
        p->oldY = p->y;
        p->oldPattern = p->pattern;
    }
}
