#include "Vram.h"
#include "Chars.h"
#include "Sprite.h"
#include "VVram.h"
#include "CopyMemory.h"
#include"Fort.h"
#include "Barrier.h"

extern byte[] MonoPatternSource, ColorPatternSource, SpritePattern;
constexpr byte SourceCharSize = 8 * 3;

byte[48 * Char_End] CharPattern;

void InitVram()
{
    ClearScreen();
    MakePatternMono(Char_Ascii, MonoPatternSource + Char_Ascii * CharHeight, 64, 0x07);
    MakePatternMono(Char_Logo, MonoPatternSource + Char_Logo * CharHeight, 16, 0x05);
    MakePatternMono(Char_Barrier, MonoPatternSource + Char_Barrier * CharHeight, 1, 0x06);
    MakePatternColor(Char_BarrierHead, ColorPatternSource, Char_End - Char_BarrierHead);
}


void DrawAll()
{
    if (VVramChanged) {
        VVramBackToFront();
        DrawFort();
        DrawBarriers();
        VVramChanged = false;
    }
    EraseSprites();
    VVramToVram();
    DrawSprites();
    SwapVram();
}


word PrintC(word vram, byte c)
{
    return Put(vram, c - ' ');
}


// void Put2(word vram, byte c)
// {
//     repeat (2) {
//         repeat (2) {
//             vram = Put(vram, c);
//             ++c;
//         }
//         vram += VramRowSize - 2 * VramStep;
//     }
// }

// void Erase2(word vram)
// {
//     repeat (2) {
//         repeat (2) {
//             vram = Put(vram, Char_Space);
//         }
//         vram += VramRowSize - 2 * VramStep;
//     }
// }

// void Put4(word vram, ptr<byte> pBytes)
// {
//     repeat(4) {
//         repeat(4) {
//             Put(vram, *pBytes);
//             ++pBytes;
//             vram += VramStep;
//         }
//         vram += VramRowSize - 4 * VramStep;
//     }
// }